function f = energy2d(psis,Hw,W,theta,lambda)
% linear part
f = norm(sqrt(lambda/2).*psis)^2;
% reshape
psis = reshape(psis,size(Hw{2},1),size(Hw{1},1));
% Spectral to real transforms
psir = Hw{2}'*(psis*Hw{1});
% nonlinear part
f = f+sum(sum((W.*abs(psir).^2+theta*abs(psir).^4/2)));
