function mainrk
addpath('Hermite');
addpath(['..',filesep,'common']);
NH = 64;
N = 1;
h = 1;
d = 1;
c = 1;
m = 1;
omega = [1,1];
beta = sqrt(omega);
[phis0,Hw,lambda,W] = init2drk(N,NH,h,d,c,beta,@potential,m,omega) 
tmax = 1;
odeoptions = odeset('RelTol',1e-8,'AbsTol',1e-8);
[t,sol] = ode45(@rhs,[0,tmax],psis0,odeoptions,W,Hw,lambda);

function z = potential(x,y,m,omega)
z = m*(omega(1)^2*x.^2+omega(2)^2*y.^2)/2;