function x = modJinv2dsys(d,phis,b)
% [X] = modJinv2sys(d,phis,b)
l = length(phis)-1;
NH2 = length(phis{1});
[c{1:l}] = deal(zeros(NH2,1));
for i = l:-1:1
  c{i} = -2*phis{i};
  ann = -c{i}'*(c{i}./d{i});
  bnn = b{l+1}(i)-c{i}'*(b{i}./d{i});
  x(l*NH2+i) = bnn/ann;
  x((i-1)*(end-l)/l+1:i*(end-l)/l) = ...
      (b{i}-...
       c{i}*x(l*NH2+i))./d{i};
end
x = x(:);
